'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _BaseModule = require('./BaseModule');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// 单字切分模块
let SingleTokenizer = function (_Tokenizer) {
  (0, _inherits3.default)(SingleTokenizer, _Tokenizer);

  function SingleTokenizer() {
    (0, _classCallCheck3.default)(this, SingleTokenizer);
    return (0, _possibleConstructorReturn3.default)(this, (SingleTokenizer.__proto__ || Object.getPrototypeOf(SingleTokenizer)).apply(this, arguments));
  }

  (0, _createClass3.default)(SingleTokenizer, [{
    key: 'split',
    value: function split(words) {
      const POSTAG = this.segment.POSTAG;
      let ret = [];
      for (var i = 0, word; word = words[i]; i++) {
        if (word.p) {
          ret.push(word);
        } else {
          // 仅对未识别的词进行匹配
          ret = ret.concat(this.splitSingle(word.w));
        }
      }
      return ret;
    }

    /**
     * 单字切分
     *
     * @param {string} text 要切分的文本
     * @param {int} cur 开始位置
     * @return {array}
     */

  }, {
    key: 'splitSingle',
    value: function splitSingle(text, cur) {
      const POSTAG = this.segment.POSTAG;
      if (isNaN(cur)) cur = 0;
      const ret = [];
      while (cur < text.length) {
        ret.push({
          w: text.charAt(cur),
          p: POSTAG.UNK
        });
        cur++;
      }
      return ret;
    }
  }]);
  return SingleTokenizer;
}(_BaseModule.Tokenizer);

exports.default = SingleTokenizer;